package test;

import java.util.List;

import org.eclipse.persistence.dynamic.DynamicEntity;
import org.eclipse.persistence.dynamic.DynamicTypeBuilder;
import org.eclipse.persistence.jpa.dynamic.JPADynamicTypeBuilder;
import org.eclipse.persistence.logging.SessionLog;
import org.eclipse.persistence.queries.ReadAllQuery;
import org.eclipse.persistence.sessions.DatabaseLogin;
import org.eclipse.persistence.sessions.DatabaseRecord;


public class EmpDep
{
    EntityContainer ec;
    DynamicTypeBuilder empBuilder;
    DynamicTypeBuilder depBuilder;
    DynamicTypeBuilder phoneBuilder;

    EmpDep()
    {
        DatabaseLogin login = new DatabaseLogin();
        login.setUserName("*****");
        login.setPassword("*****");
        login.setDriverURLHeader("jdbc:oracle:thin:@");
        login.setDriverClassName("oracle.jdbc.OracleDriver");
        login.setDatabaseURL("*****************");
        ec = new EntityContainer(login);
        ec.getDatabaseSession().setLogLevel(SessionLog.FINEST);

        createTypes();
    }

    void createEmployeeType()
    {
        Class<?> empType = ec.getDynamicClassLoader().createDynamicClass("jpatest.empinfo");
        empBuilder = new JPADynamicTypeBuilder(empType, null, "emp_empdep");
        empBuilder.setPrimaryKeyFields("id");
        empBuilder.addDirectMapping("id", int.class, "id");
        empBuilder.addDirectMapping("name", String.class, "name");

    }

    void createDepartmentType()
    {
        Class<?> depType = ec.getDynamicClassLoader().createDynamicClass("jpatest.depinfo");
        depBuilder = new JPADynamicTypeBuilder(depType, null, "dep_empdep");
        depBuilder.setPrimaryKeyFields("depid");
        depBuilder.addDirectMapping("depid", int.class, "depid");
        depBuilder.addDirectMapping("depname", String.class, "depname");
    }

    void createPhoneType()
    {
        Class<?> phoneType = ec.getDynamicClassLoader().createDynamicClass("jpatest.phoneinfo");
        phoneBuilder = new JPADynamicTypeBuilder(phoneType, null, "phone_empdep");
        phoneBuilder.setPrimaryKeyFields("phoneid");
        phoneBuilder.addDirectMapping("phoneid", int.class, "phoneid");
        phoneBuilder.addDirectMapping("phone", String.class, "phone");
    }

    void createTypes()
    {
        createEmployeeType();
        createDepartmentType();
        createPhoneType();
        depBuilder.addOneToManyMapping("empinfo.depinfo", empBuilder.getType(), "depid");//.setUsesIndirection(false);
        empBuilder.addOneToOneMapping("empinfo.depinfo", depBuilder.getType(), "depid");//.setUsesIndirection(false);

        empBuilder.addOneToManyMapping("empinfo.phoneinfo", phoneBuilder.getType(), "empid");//.setUsesIndirection(false);
        phoneBuilder.addOneToOneMapping("empinfo.phoneinfo", empBuilder.getType(), "empid");//.setUsesIndirection(false);

        ec.getHelper().addTypes(false, true, empBuilder.getType(), depBuilder.getType(), phoneBuilder.getType());
    }

    @SuppressWarnings("unchecked")
    void printall()
    {
        ReadAllQuery query = ec.getHelper().newReadAllQuery(empBuilder.getType().getDescriptor().getAlias());
        query.addJoinedAttribute(query.getExpressionBuilder().getAllowingNull("empinfo.depinfo"));
        query.addJoinedAttribute(query.getExpressionBuilder().anyOfAllowingNone("empinfo.phoneinfo"));
        query.addOrdering(query.getExpressionBuilder().get("id"));

        query.prepareCall(ec.getDatabaseSession(), new DatabaseRecord());
        System.out.println("query: " + query.getSQLString());
        
        ec.printEntities((List<DynamicEntity>) ec.getDatabaseSession().executeQuery(query));
    }
}
