package test;

import java.util.HashSet;
import java.util.Set;
import java.util.Vector;

import org.eclipse.persistence.dynamic.DynamicEntity;
import org.eclipse.persistence.logging.SessionLog;
import org.eclipse.persistence.sessions.DatabaseSession;
import org.eclipse.persistence.sessions.UnitOfWork;
import org.eclipse.persistence.sessions.changesets.ChangeRecord;
import org.eclipse.persistence.sessions.changesets.ObjectChangeSet;
import org.eclipse.persistence.sessions.changesets.UnitOfWorkChangeSet;

public class EmpDepUpdate
{
    public static void main(String[] args)
    {
        EmpDep ed = new EmpDep();

        DatabaseSession session = ed.ec.getDatabaseSession();

        UnitOfWork uow = session.acquireUnitOfWork();
        uow.setLogLevel(SessionLog.FINEST);
        uow.performFullValidation();

        DynamicEntity oldEmp = ed.ec.getHelper().newDynamicEntity(ed.empBuilder.getType().getName());
        oldEmp.set("id", 147);
        oldEmp = (DynamicEntity) uow.readObject(oldEmp);
        DynamicEntity oldDep = ed.ec.getHelper().newDynamicEntity(ed.depBuilder.getType().getName());
        oldDep.set("depid", 1010);
        oldDep = (DynamicEntity) uow.readObject(oldDep);
        oldEmp.set("empinfo.depinfo", oldDep);
        UnitOfWorkChangeSet changeSet = uow.getCurrentChanges();

        for (ObjectChangeSet cs : (Set<ObjectChangeSet>)changeSet.getAllChangeSets().keySet())
        {
            System.out.println("changes");
            System.out.println(cs.getChangedAttributeNames());
            System.out.println(cs.getId());
            for (ChangeRecord changeRecord : cs.getChanges())
            {
                System.out.println(changeRecord.getAttribute());
                System.out.println(changeRecord.getOwner());
            }
        }

        uow.printRegisteredObjects();
        uow.commit();
    }
    
}
